const express = require("express");
const app = express();
const bodyParser = require("body-parser");
const mysql = require("mysql2");
const cors = require("cors");
const multer = require('multer');
const crypto = require("crypto");
const path = require('path');
const fs = require('fs'); 
const nodemailer = require('nodemailer');
const { v4: uuidv4 } = require('uuid');
const bcrypt = require('bcrypt');

const emailjs = require("emailjs-com");
const csv = require('csv-parser');
const axios = require('axios');

const { createCanvas, registerFont } = require('canvas');



const { createObjectCsvWriter } = require('csv-writer');
const uploa = multer({ dest: 'uploads/' });
const emailConfig = {
  serviceId: "service_vafdalo", 
  templateId: "template_wyfafr9",
};

const stripe = require('stripe')('sk_test_51McMOgSGBtZlYPTYPmYUkwpsnvWBkwCqgb60dHKDZVSP5rNDNFyOWa6sNHyiL8mBBQh0auDzUTGvfAldJa8sqiiB00yakfJhhg');

 const { check, validationResult, param } = require('express-validator');



const storage = multer.diskStorage({
  destination: function (req, file, cb) {
    cb(null, 'uploads/');
  },
  filename: function (req, file, cb) {
    cb(null, Date.now() + '-' + file.originalname);
  }
});

const upload = multer({ storage: storage });


const db = mysql.createPool({
  host: "localhost",
  user: "root",
  password: "root",
  database: "mumber4"
});



app.use(cors());
app.use(express.json());
app.use(bodyParser.json());
app.use(bodyParser.urlencoded({ extended: true }));

var OAuthClient = require('intuit-oauth');
app.get("/payment",(req, res)=>{

  const gateway_set = "SELECT * FROM gateway_settings where id=1";
  db.query(gateway_set, (error, results) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: "Internal Server Error"
      });
    }
    console.log(results);

    var oauthClient = new OAuthClient({
      clientId: results[0].client_id,//'ABIKgkQA2tyweSBgpAWQoTkE28o2n2BpRKVDkk4eAOohyjZyY9',            // enter the apps `clientId`
      clientSecret: results[0].client_secret,//'SnHQwNZQZLtxf5GVfiH8JdHh2c1ipVlWDgTtbqev',    // enter the apps `clientSecret`
      environment: 'sandbox',     // enter either `sandbox` or `production`
      redirectUri: 'https://node.mumber.com/callback',      // enter the redirectUri
      logging: true                               // by default the value is `false`
    });

    const authUri = oauthClient.authorizeUri({
      scope: [OAuthClient.scopes.Payment, OAuthClient.scopes.Accounting, OAuthClient.scopes.OpenId],
      state: 'testState',
    }); // can be an array of multiple scopes ex : {scope:[OAuthClient.scopes.Accounting,OAuthClient.scopes.OpenId]}
    
    res.redirect(authUri);
    
  });

  
  
  
  // AuthorizationUri
  
});


app.get("/callback",(req, res)=>{

  const gateway_set = "SELECT * FROM gateway_settings where id=1";
  db.query(gateway_set, (error, results) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: "Internal Server Error"
      });
    }

  var oauthClient = new OAuthClient({
    clientId: results[0].client_id,            // enter the apps `clientId`
    clientSecret: results[0].client_secret,    // enter the apps `clientSecret`
    environment: 'sandbox',     // enter either `sandbox` or `production`
    redirectUri: 'https://node.mumber.com/callback',      // enter the redirectUri
    // logging: true                               // by default the value is `false`
  });

  const parseRedirect = req.url;
  console.log(parseRedirect);

  // const code = parseRedirect.split("&")[0].replace("/callback?code=", "");
  //  console.log(code);




  oauthClient
  .createToken(parseRedirect)
  .then(function (authResponse) {
    console.log(authResponse.getJson());

    const query = `UPDATE payment SET access_token = '${authResponse.getJson().access_token}', refresh_token='${authResponse.getJson().refresh_token}' WHERE id = ?`;
    db.query(query, [1], (error, results) => {
      if (error) {
        console.error('Error marking notifications as read:', error);
        // res.status(500).json({ error: 'Failed to mark notifications as read' });
      } else {
        // res.status(200).json({ message: 'Notifications marked as read successfully' });
      }
  
    
    });
  })
  .catch(function (e) {
    console.error('The error message is :' + e.originalMessage);
    console.error(e.intuit_tid);
    console.error(e);
  });



  // oauthClient
  // .refreshUsingToken('AB11695540139D2oeyM5I0cHdXBIH3vXxU8WT4Z2gU9JSDe7rw')
  // .then(function (authResponse) {
  //   console.log(authResponse.getJson());
  // })
  // .catch(function (e) {
  //   console.error('The error message is :' + e.originalMessage);
  //   console.error(e);
  // });
  

  res.send("token");

});
});


app.get('/api/getToken', async (req, res) => {


  try {

    let ref_token = '';
    const query = `SELECT * FROM payment WHERE id=?`;
    db.query(query, [1], (error, results) => {
      if (error) {
        console.error('Error fetching notifications:', error);

        // res.status(500).json({ error: 'Failed to fetch payment' });
      } else {
        console.log(results);

        let ref_token = results[0].refresh_token;

        const gateway_set = "SELECT * FROM gateway_settings where id=1";
  db.query(gateway_set, (error, results) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: "Internal Server Error"
      });
    }
       
    var oauthClient = new OAuthClient({
      clientId: results[0].client_id,            // enter the apps `clientId`
      clientSecret: results[0].client_secret,    // enter the apps `clientSecret`
      environment: 'sandbox',     // enter either `sandbox` or `production`
      redirectUri: 'https://node.mumber.com/callback',      // enter the redirectUri
      // logging: true                               // by default the value is `false`
    });

    oauthClient
  .refreshUsingToken(ref_token)
  .then(function (authResponse) {
    // new_token = ;
    console.log(authResponse.getJson());

    const query = `UPDATE payment SET access_token = '${authResponse.getJson().access_token}', refresh_token='${authResponse.getJson().refresh_token}' WHERE id = ?`;
    db.query(query, [1], (error, results) => {
      if (error) {
        console.error('Error marking notifications as read:', error);
        // res.status(500).json({ error: 'Failed to mark notifications as read' });
      } else {
        // res.status(200).json({ message: 'Notifications marked as read successfully' });
      }

    
    });

    res.send(authResponse.getJson().access_token);
    
  })
  .catch(function (e) {
    console.error('The error message is :' + e.originalMessage);
    console.error(e);
  });
  });
  
      }

      
      // Close the MySQL connection
      // connection.end();
    });
  // console.log(new_token);
  } catch (error) {
    console.error('Error connecting to MySQL:', error);
    // res.status(500).json({ error: 'Failed to connect to the database' });
  }
});









app.get('/generate-image', (req, res) => {

  const excludesarr = [
    '202',
    '727',
    '863',
    '912',
    '229',
    '773/872',
    '309',
    '765',
    '620',
    '504',
    '413',
    '810',
    '734',
    '989',
    '906',
    '231',
    '763',
    '651',
    '218',
    '507',
    '908',
    '575',
    '315/680',
    '914',
    '513',
    '614/380',
    '937',
    '503',
    '352',
    '217',
    '317/463',
    '985',
    '401',
    '803',
    '940',
    '435',
    '804',
    '802',
    '206',
    '816',
    '308',
    '509',
    '715/534',
    '304/681',
    '307',
    '740/220',
    '580',
    '570/272',
    '276',
    '540',
    '757',
    '425',
    '253',
    '340',
    '870',
    '951',
    '909',
    '619',
    '949',
    '925',
    '858',
    '818/747',
    '760/442',
    '408/669',
    '707',
    '650',
    '626',
    '323',
    '530',
    '510',
    '970',
    '302',
    '772',
    '787/939',
    '479',
    '714/657',
    '310/424',
    '954/754',
    '770/470/678',
    '847/224',
    '815/779',
    '630/331',
    '508/774',
    '978/351',
    '781/339',
    '301/240',
    '601/769',
    '252',
    '973/862',
    '732/848',
    '201/551',
    '212/332/646/917',
    '718,347,917/929',
    '330/324',
    '541/458',
    '610/484',
    '903/430',
    '817/682',
    '512/737',
    '305/786',
    '310/424'
  ];

  // console.log(req.query);
  const text = "  "; // Assuming the text is passed as a query parameter
  const color_code = req.query.color; // Assuming the text is passed as a query parameter

  // Create a canvas and context
  const canvas = createCanvas(1, 20);
  const ctx = canvas.getContext('2d');

  // Set the font size and measure the text width
  const fontSize = 15;
  ctx.font = `${fontSize}px FontName`;
  const textWidth = ctx.measureText(text).width;

  // Set the canvas width based on the text width
  canvas.width = textWidth + 9; // Adding extra padding

  // Create a new context with the updated width
  const ctx2 = canvas.getContext('2d');

  // Set the background color to white
  if(excludesarr.includes(text)){
    ctx2.fillStyle = '#999';
  }else{
    ctx2.fillStyle = '#fff';
  }
  
  ctx2.fillRect(0, 0, canvas.width, canvas.height);

  // Draw the text on the canvas
  ctx2.font = `${fontSize}px FontName`;
  ctx2.fillStyle = '#000'; // Set the text color to black
  ctx2.fillText(text, 5, 15);

  // Add a rounded border
  ctx2.strokeStyle = '#000'; // Set the border color to black
  ctx2.lineWidth = 2; // Set the border width
  ctx2.lineJoin = 'round'; // Set the line join style to round
  ctx2.strokeRect(0, 0, canvas.width, canvas.height);

  // Convert the canvas to a buffer representing the image data
  const buffer = canvas.toBuffer('image/png');

  // Set the appropriate response headers
  res.set('Content-Type', 'image/png');
  res.set('Content-Disposition', 'inline; filename=image.png');

  // Send the image data as the response
  res.send(buffer);
});



// app.get('/generate-image', (req, res) => {
//   const text = req.query.text; // Assuming the text is passed as a query parameter

//   // Create a canvas and context
//   const canvas = createCanvas(1, 200);
//   const ctx = canvas.getContext('2d');

//   // Set the font size and measure the text width
//   const fontSize = 88;
//   ctx.font = `${fontSize}px FontName`;
//   const textWidth = ctx.measureText(text).width;

//   // Set the canvas width based on the text width
//   canvas.width = textWidth + 100; // Adding extra padding

//   // Create a new context with the updated width
//   const ctx2 = canvas.getContext('2d');

//   // Draw the text on the canvas
//   ctx2.font = `${fontSize}px FontName`;
//   ctx2.fillText(text, 50, 125);

//   // Save the canvas as an image file
//   const filePath = 'uploads/map_img/image'+text.replace(/\//g, "-");+'.png';
//   const out = fs.createWriteStream(filePath);
//   const stream = canvas.createPNGStream();
//   stream.pipe(out);
//   out.on('finish', () => {
//     // Send the image URL as the response
//     res.json({ imageUrl: `http://example.com/image.png` });
//   });
// });



app.put('/api/mark-read/:userId', async (req, res) => {
  const { userId } = req.params;

  try {
   
    // Execute the MySQL query to update the status of notifications to "read" for the given userId
    const query = `UPDATE notification SET status = 'read' WHERE user_id = ?`;
    db.query(query, [userId], (error, results) => {
      if (error) {
        console.error('Error marking notifications as read:', error);
        res.status(500).json({ error: 'Failed to mark notifications as read' });
      } else {
        res.status(200).json({ message: 'Notifications marked as read successfully' });
      }

    
    });
  } catch (error) {
    console.error('Error connecting to MySQL:', error);
    res.status(500).json({ error: 'Failed to connect to the database' });
  }
});


app.get('/api/notify2/:userId', async (req, res) => {
  const { userId } = req.params;

  try {
    const query = `SELECT * FROM notification status='unread'`;
    db.query(query, [userId], (error, results) => {
      if (error) {
        console.error('Error fetching notifications:', error);
        res.status(500).json({ error: 'Failed to fetch notifications' });
      } else {
        res.json(results);
      }

      // Close the MySQL connection
      // connection.end();
    });
  } catch (error) {
    console.error('Error connecting to MySQL:', error);
    res.status(500).json({ error: 'Failed to connect to the database' });
  }
});

app.get('/api/notify/:userId', async (req, res) => {
  const { userId } = req.params;

  try {
    const query = `SELECT * FROM notification WHERE user_id = ? and status='unread'`;
    db.query(query, [userId], (error, results) => {
      if (error) {
        console.error('Error fetching notifications:', error);
        res.status(500).json({ error: 'Failed to fetch notifications' });
      } else {
        res.json(results);
      }

      // Close the MySQL connection
      // connection.end();
    });
  } catch (error) {
    console.error('Error connecting to MySQL:', error);
    res.status(500).json({ error: 'Failed to connect to the database' });
  }
});






app.post('/signup', (req, res) => {
  const sqlInsertUser = "INSERT INTO users (name, email, password) VALUES (?, ?, ?)";
  const userValues = [
    req.body.name,
    req.body.email,
    req.body.password
  ];

  db.query(sqlInsertUser, userValues, (err, userData) => {
    if (err) {
      console.error('Error inserting user:', err);
      return res.json("Error");
    }

    const sqlInsertNotification = "INSERT INTO notification (title, message, notify_to, user_id) VALUES (?, ?, ?, ?)";
    const notificationValues = [
      "Welcome to our platform",
      "Thank you for signing up!",
      "User",
      // req.body.email,
      userData.insertId
    ];

    db.query(sqlInsertNotification, notificationValues, (err, notificationData) => {
      if (err) {
        console.error('Error inserting notification:', err);
        return res.json("Error");
      }

      return res.json({ user: userData, notification: notificationData });
    });
  });
});

app.get('/notifications', (req, res) => {
  const sql = "SELECT * FROM notification";

  db.query(sql, (err, data) => {
    if (err) {
      console.error('Error fetching notifications:', err);
      return res.json("Error");
    }
    return res.json(data);
  });
});





app.get('/api/users/:userId', (req, res) => {
  const { userId } = req.params;

  // Query the database to fetch user data by userId
  const sql = 'SELECT * FROM users WHERE id = ?';
  db.query(sql, [userId], (error, results) => {
    if (error) {
      console.error('Error retrieving user data:', error);
      res.status(500).json({ error: 'Internal Server Error' });
    } else if (results.length === 0) {
      res.status(404).json({ error: 'User not found' });
    } else {
      const user = results[0];
      res.status(200).json(user);
    }
  });
});


app.put('/api/users/:id', (req, res) => {
  const userId = req.params.id;
  const { password } = req.body;

  // Hash the new password using bcrypt
  bcrypt.hash(password, 10, (err, hashedPassword) => {
    if (err) {
      console.error('Error hashing password:', err);
      res.status(500).json({ error: 'Error hashing password' });
      return;
    }

    // Update the user's password in the database
    const updateQuery = 'UPDATE users SET password = ? WHERE id = ?';

    db.query(updateQuery, [hashedPassword, userId], (err, results) => {
      if (err) {
        console.error('Error updating password:', err);
        res.status(500).json({ error: 'Error updating password' });
        return;
      }

      console.log(`Password updated for user with ID ${userId}`);

      // Send a success response
      res.status(200).json({ message: 'Password updated successfully' });
    });
  });
});



app.get('/api/download', (req, res) => {
  // Fetch data from your database
  const products = [
    {
      phone_no: '1234567890',
      SKU: 'ABC123',
      Categories: 'Electronics',
      State: 'California',
      City: 'Los Angeles',
      area_code: '12345',
      monthly: '49.99',
      yearly: '499.99',
      Description: 'New York, Buffalo .....',
    },
    // Add more product objects as needed
  ];

  // Define CSV header and columns
  const csvHeader = [
    { id: 'phone_no', title: 'Phone Number' },
    { id: 'SKU', title: 'SKU' },
    { id: 'Categories', title: 'Categories' },
    { id: 'State', title: 'State' },
    { id: 'City', title: 'City' },
    { id: 'area_code', title: 'Area Code' },
    { id: 'monthly', title: 'Monthly Price' },
    { id: 'yearly', title: 'Yearly Price' },
    { id: 'Description', title: 'Description' },
  ];

  const csvWriter = createObjectCsvWriter({
    path: './uploads/products.csv', // Path where the CSV file will be stored
    header: csvHeader,
  });

  // Write the data to the CSV file
  csvWriter.writeRecords(products)
    .then(() => {
      console.log('CSV file created successfully');
      // Send the CSV file as a response
      res.download('./uploads/products.csv');
    })
    .catch((error) => {
      console.error('Error creating CSV:', error);
      res.status(500).send('Internal Server Error');
    });
});



app.post('/api/import', upload.single('file'), (req, res) => {
  const filePath = req.file.path;

  const results = [];
  fs.createReadStream(filePath)
    .pipe(csv())
    .on('data', (data) => results.push(data))
    .on('end', () => {
      // Extract phone numbers from the CSV
      const phoneNumbers = results.map((result) => result['Phone Number']);

      // Check for duplicate phone numbers in the database
      const sqlCheckDuplicate = 'SELECT phone_no FROM product WHERE phone_no IN (?)';
      db.query(sqlCheckDuplicate, [phoneNumbers], (error, duplicateResults) => {
        if (error) {
          console.error('Error checking for duplicate phone numbers:', error);
          res.status(500).send('Internal Server Error');
        } else {
          console.log(duplicateResults);
          const duplicatePhoneNumbers = duplicateResults.map((result) => result.phone_no);

          // Loop through the CSV records
          results.forEach((record) => {
            if (duplicatePhoneNumbers.includes(record['Phone Number'])) {
              // Update the existing record

              var yearly = (parseFloat(record['Monthly Price']) * 12);
              yearly = yearly - ((5 * yearly)/100);
             
              const sqlUpdate =
                'UPDATE product SET monthly = ?, yearly = ? WHERE phone_no = ?';

              const updateParams = [
               
                record['Monthly Price'],
                yearly,
                record['Phone Number']
              ];

              db.query(sqlUpdate, updateParams, (error, updateResult) => {
                if (error) {
                  console.error('Error updating record:', error);
                } else {
                  // console.log('Record updated:', updateResult);
                }
              });
            } else {

              var yearly = (parseFloat(record['Monthly Price']) * 12);
              yearly = yearly - ((5 * yearly)/100);
              console.log(record['Phone Number']);
              console.log(record['Monthly Price']);
              // Insert a new record
              const sqlInsert =
                'INSERT INTO product (phone_no, SKU, Categories, State, City, area_code, monthly, yearly, Description, toll_free, no_price, nickname) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)';

              const insertParams = [
                record['Phone Number'],
                record['SKU'],
                record['Categories'],
                record['State'],
                record['City'],
                record['Area Code'],
                record['Monthly Price'],
                yearly,
                record['Description'],
                record['Toll free'] || 0,
                record['No price'] || 0,
                record['nickname']
              ];

              db.query(sqlInsert, insertParams, (error, insertResult) => {
                if (error) {
                  console.error('Error inserting record:', error);
                } else {
                  console.log('Record inserted:', insertResult);
                }
              });
            }
          });

          // Remove the uploaded file
          fs.unlinkSync(filePath);

          // Send a response
          res.status(200).send('CSV file imported successfully');
        }
      });
    })
    .on('error', (error) => {
      console.error('Error importing CSV:', error);
      res.status(500).send('Internal Server Error');
    });
});









// app.post("/api/register", (req, res) => {
//   const { username } = req.body;
//   const { email } = req.body;

//   const { password } = req.body;
//   const sqlInsert =
//     "INSERT INTO users (username, email, password) VALUES (?,?,?)";
//   db.query(sqlInsert, [username,email,password ], (error, result) => {
//     if (error) {
//       console.log(error);
     
//     }
// else{
//   res.send(result);


// }
//   });
// });





app.post("/api/register", (req, res) => {
  const { name, email, role , password , company_name } = req.body;

  // Check if the email already exists in the database
  const sqlSelect = "SELECT * FROM users WHERE email = ?";
  db.query(sqlSelect, [email], (selectError, selectResult) => {
    if (selectError) {
      console.log(selectError);
      return res.status(500).json({
        success: false,
        message: "Internal Server Error"
      });
    }

    if (selectResult.length > 0) {
      return res.status(400).json({
        success: false,
        message: "Email already registered"
      });
    }

    // Hash the password
    bcrypt.hash(password, 10, (hashError, hash) => {
      if (hashError) {
        console.log(hashError);
        return res.status(500).json({
          success: false,
          message: "Internal Server Error"
        });
      }

      const sqlInsert =
        "INSERT INTO users (name, email,role , password, company_name) VALUES (?,?,?,?,?)";
      db.query(sqlInsert, [name, email,role , hash, company_name], (insertError, result) => {
        if (insertError) {
          console.log(insertError);
          return res.status(500).json({
            success: false,
            message: "Internal Server Error"
          });
        }

        // Send welcome email to the user
        const transporter = nodemailer.createTransport({
          // Configure your email provider here
          // Example using Gmail:
          service: "gmail",
          auth: {
            user: "mumberinvoice@gmail.com",
            pass: "sdwartoahkijpjdt"
          }
        });

        const mailOptions = {
          from: "your-email@gmail.com",
          to: email,
          subject: "Welcome to Your Mumber App",
          html: `
            <h2>Welcome to Mumber!</h2>
            <p>Dear ${name},</p>
            <p>Thank you for registering on our platform.</p>
            <p>We're excited to have you on board!</p>
            <p>Best regards,</p>
            <p>Mumber Team</p>
          `
        };

        transporter.sendMail(mailOptions, (emailError, info) => {
          if (emailError) {
            console.log(emailError);
            return res.status(500).json({
              success: false,
              message: "Failed to send email"
            });
          }
          console.log("Email sent:", info.response);
          const data = {
            name,
            email,
            password,
            company_name,
            role
          };
          res.json({
            success: true,
            message: "Registration successful. Welcome email sent.",
            data: data
          });
        });
      });
    });
  });
});







app.post("/api/login", (req, res) => {
  const { email, password } = req.body;

  const sqlSelect = "SELECT * FROM users WHERE email=?";
  db.query(sqlSelect, [email], (error, result) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: "Internal Server Error"
      });
    }

    if (result.length === 0) {
      return res.status(401).json({
        success: false,
        message: "User not found"
      });
    }

    const user = result[0];

    // Compare the entered password with the hashed password in the database
    bcrypt.compare(password, user.password, (err, passwordMatch) => {
      if (err) {
        console.log(err);
        return res.status(500).json({
          success: false,
          message: "Internal Server Error"
        });
      }

      if (passwordMatch) {
        // Passwords match, user is authenticated
        // You can generate a JWT token or set a session here for authentication

        res.json({
          success: true,
          message: "Login successful",
          data: user // You can send user information here if needed
        });
      } else {
        // Passwords do not match
        res.status(401).json({
          success: false,
          message: "Incorrect password"
        });
      }
    });
  });
});



////////////////////////////////////////////////////////////////////////////////////////////////////////

//                                             PASSWORD

//////////////////////////////////////////////////////////////////////////////////////////////////////


const transporter = nodemailer.createTransport({
  service: 'gmail',
  auth: {
    
    user: "mumberinvoice@gmail.com",
    pass: "sdwartoahkijpjdt"
  }
});

// Generate a reset token using UUID
const generateResetToken = () => {
  const token = uuidv4();
  return token;
};

app.post('/api/forgot-password', async (req, res) => {
  const { email } = req.body;

  try {
    const checkEmailQuery = 'SELECT * FROM users WHERE email = ?';
    const [rows] = await db.promise().query(checkEmailQuery, [email]);

    if (rows.length === 0) {
      // Email not found in the database
      return res.status(404).json({ error: 'Email not found' });
    }

    const resetToken = generateResetToken();
    const updateQuery = 'UPDATE users SET reset_token = ? WHERE email = ?';
    await db.promise().query(updateQuery, [resetToken, email]);

    await sendPasswordResetEmail(email, resetToken);

    res.json({ success: true, message: 'Password reset link sent successfully' });
  } catch (error) {
    console.error(error);
    res.status(500).json({ error: error.message || 'Internal Server Error' });
  }
});


// Function to send the password reset email
const sendPasswordResetEmail = (email, resetToken) => {
  return new Promise((resolve, reject) => {
    const mailOptions = {
      from: 'mumbersite',
      to: email,
      subject: 'Password Reset',
      text: `Dear user, to reset your password, click the following link: http://mumber2.dcwebtech.com/reset-password?token=${resetToken}`,
    };

    transporter.sendMail(mailOptions, (error, info) => {
      if (error) {
        console.log('Error sending email:', error);
        reject(error);
      } else {
        console.log('Email sent: ' + info.response);
        resolve();
      }
    });
    
  });
};



app.post("/api/reset-password", (req, res) => {
  const { password, resetToken } = req.body;

  // Hash the new password using bcrypt
  bcrypt.hash(password, 10, (err, hashedPassword) => {
    if (err) {
      console.error(err);
      return res.status(500).json({ error: "Internal Server Error" });
    }

    const updateQuery = "UPDATE users SET password = ? WHERE reset_token = ?";
    db.query(updateQuery, [hashedPassword, resetToken], (error, result) => {
      if (error) {
        console.error(error);
        res.status(500).json({ error: "Internal Server Error" });
      } else if (result.affectedRows === 0) {
        // No rows updated, indicating invalid reset token
        res.status(400).json({ error: "Invalid reset token" });
      } else {
        res.json({ success: true, message: "Password updated successfully" });
      }
    });
  });
});












//////////////////////////////////////////////////////////////////////////////////////////////////////

//                                               PRODUCTS

//////////////////////////////////////////////////////////////////////////////////////////////////////////

app.get("/api/get",(req, res)=>{
  const sqlGet = "SELECT * FROM product WHERE Is_sold = 0";
  db.query(sqlGet, (error, result) => {
  
      res.send(result);

});
});

app.get("/api/get_d/:filter",(req, res)=>{
  const {filter} = req.params;
 
  
  //const sqlGet = "SELECT * FROM  product where phone_no = ? ";
//   const sqlGet = "SELECT * FROM  product where phone_no LIKE ? OR area_code = ? OR City = ? OR State = ? ";
//   db.query(sqlGet, [`%${filter}%`, `${filter}`, `%${filter}%`, `%${filter}%`], (error, result) => {
//       res.send(result);

// });

const sql = `SELECT * FROM product WHERE phone_no LIKE '${filter}%' OR Description LIKE '%${filter}%'  OR nickname LIKE '%${filter}%'`;
  db.query(sql, (err, result) => {
    if (err) throw err;
    res.json(result);
  });
});



app.get("/api/get_allblog/:filter",(req, res)=>{
  const {filter} = req.params;
const sql = `SELECT * FROM blogs WHERE Id LIKE '${filter}%' OR Description LIKE '%${filter}%'`;
  db.query(sql, (err, result) => {
    if (err) throw err;
    res.json(result);
  });
});



  app.get("/api/get_data/:id",(req, res)=>{
  const {id} = req.params;
  //const sqlGet = "SELECT * FROM  product where phone_no = ? ";
  const sqlGet = "SELECT * FROM  product where id = ?";
  db.query(sqlGet, id, (error, result) => {
      res.send(result);

});
});





// app.get("/api/allproducts", (req, res) => {
//   const sqlSelect = "SELECT * FROM product  ORDER BY Id DESC";
//   db.query(sqlSelect, (error, results) => {
//     if (error) {
//       console.log(error);
//       return res.status(500).json({
//         success: false,
//         message: "Internal Server Error"
//       });
//     }

//     res.json({
//       success: true,
//       data: results
//     });
//   });
// });



// app.get("/api/filterproducts", (req, res) => {
//   const sqlGet = "SELECT * FROM product";
//   db.query(sqlGet, (error, results) => {
//     if (error) {
//       console.log(error);
//       return res.status(500).json({
//         success: false,
//         message: "Internal Server Error"
//       });
//     }

//     res.json({
//       success: true,
//       data: results
//     });
//   });
// });




app.get("/api/allproducts", (req, res) => {
  const page = parseInt(req.query.page) || 1;
  const perPage = parseInt(req.query.perPage) || 10;
  const startIndex = (page - 1) * perPage;
  const search = req.query.search || '';

  // Use parameterized queries to prevent SQL injection
  const sqlGet = `SELECT * FROM product WHERE phone_no LIKE ? OR area_code LIKE ? OR Nickname LIKE ? LIMIT ?, ?`;
  const sqlCount = `SELECT COUNT(*) as total FROM product WHERE phone_no LIKE ? OR area_code LIKE ? OR Nickname LIKE ?`;

  // Create search patterns with '%' for parameterized query
  const searchPattern = `%${search}%`;

  Promise.all([
    new Promise((resolve, reject) => {
      db.query(sqlGet, [searchPattern, searchPattern, searchPattern, startIndex, perPage], (error, results) => {
        if (error) reject(error);
        else resolve(results);
      });
    }),
    new Promise((resolve, reject) => {
      db.query(sqlCount, [searchPattern, searchPattern, searchPattern], (error, results) => {
        if (error) reject(error);
        else resolve(results[0].total);
      });
    }),
  ])
    .then(([data, total]) => {
      res.json({
        success: true,
        data,
        total,
      });
    })
    .catch((error) => {
      console.log(error);
      res.status(500).json({
        success: false,
        message: "Internal Server Error",
      });
    });
});




// app.get("/api/allproducts", (req, res) => {
//   const page = parseInt(req.query.page) || 1;
//   const perPage = 10; // Number of items per page
//   const startIndex = (page - 1) * perPage;
//   const search = req.query.search || ''; // Get the search text from the query parameter

//   // Modify the SQL query to filter results based on the search text
//   const sqlGet = `SELECT * FROM product WHERE phone_no LIKE '%${search}%' OR area_code LIKE '%${search}%' LIMIT ${startIndex}, ${perPage}`;
//   const sqlCount = `SELECT COUNT(*) as total FROM product WHERE phone_no LIKE '%${search}%' OR area_code LIKE '%${search}%'`;

//   Promise.all([
//     new Promise((resolve, reject) => {
//       db.query(sqlGet, (error, results) => {
//         if (error) reject(error);
//         else resolve(results);
//       });
//     }),
//     new Promise((resolve, reject) => {
//       db.query(sqlCount, (error, results) => {
//         if (error) reject(error);
//         else resolve(results[0].total);
//       });
//     }),
//   ])
//   .then(([data, total]) => {
//     res.json({
//       success: true,
//       data,
//       total,
//     });
//   })
//   .catch((error) => {
//     console.log(error);
//     res.status(500).json({
//       success: false,
//       message: "Internal Server Error",
//     });
//   });
// });


app.get("/api/allavailproducts", (req, res) => {
  const sqlGet = "SELECT * FROM product WHERE Is_sold = 0";
  db.query(sqlGet, (error, results) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: "Internal Server Error"
      });
    }

    res.json({
      success: true,
      data: results
    });
  });
});


app.get("/api/countproducts", (req, res) => {
  const sqlGet = "SELECT COUNT(*) AS total FROM product";
  db.query(sqlGet, (error, countResult) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: "Internal Server Error",
      });
    }

    const totalCount = countResult[0].total;

    res.json({
      success: true,
      totalCount: totalCount,
    });
  });
});



// app.get('/api/product/:id', (req, res) => {
//   const productId = req.params.id;
//   const sqlGetById = 'SELECT * FROM product WHERE id = ? ';
//   db.query(sqlGetById, [productId], (error, results) => {
//     if (error) {
//       console.log(error);
//       return res.status(500).json({
//         success: false,
//         message: 'Internal Server Error'
//       });
//     }

//     if (results.length === 0) {
//       return res.status(404).json({
//         success: false,
//         message: 'Product not found'
//       });
//     }

//     res.json({
//       success: true,
//       data: results[0]
//     });
//   });
// });


app.get('/api/product/:ids', (req, res) => {
  const productIds = req.params.ids.split(','); // Split the IDs into an array

  // Use IN operator in SQL query to fetch products by multiple IDs
  const sqlGetByIds = 'SELECT * FROM product WHERE id IN (?)';
  db.query(sqlGetByIds, [productIds], (error, results) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: 'Internal Server Error'
      });
    }

    if (results.length === 0) {
      return res.status(404).json({
        success: false,
        message: 'Products not found'
      });
    }

    res.json({
      success: true,
      data: results
    });
  });
});



app.post("/api/addgatewaysettings", (req, res) => {
  const { client_id,client_secret,company_id} = req.body;
  

  const sqlUpdate = "UPDATE gateway_settings SET client_id=?, client_secret=?, company_id=? WHERE id = ?";

  db.query(sqlUpdate, [client_id, client_secret, company_id, 1], (error, result) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: "Internal Server Error"
      });
    }

    res.json({
      success: true,
      message: "Settings updated successfully"
    });
  });
});



app.post("/api/addproduct", (req, res) => {
  const { phone_no,  SKU,area_code,Nickname,  monthly ,yearly, Description} = req.body;
  const sqlInsert = "INSERT INTO product (phone_no, SKU,area_code,Nickname, monthly ,yearly, Description) VALUES (?, ?, ?,?, ?, ?,?)";
  db.query(sqlInsert, [phone_no, SKU,  area_code ,Nickname,  monthly ,yearly, Description], (error, result) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: "Internal Server Error",
      });
    }

    res.json({
      success: true,
      message: "Product added successfully",
    });
  });
});



app.put("/api/addsoldprod/:ids", (req, res) => {
  const productIds = req.params.ids.split(","); // Split the IDs into an array
  const { Is_sold } = req.body;

  // Use IN operator in SQL query to update products by multiple IDs
  const sqlUpdate = "UPDATE product SET Is_sold=? WHERE id IN (?)";
  db.query(sqlUpdate, [Is_sold, productIds], (error, result) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: "Internal Server Error"
      });
    }

    res.json({
      success: true,
      message: "Products updated successfully"
    });
  });
});



app.put("/api/updateProduct/:id", (req, res) => {
  const id = req.params.id;
  const { phone_no,  SKU,  area_code, Nickname, monthly ,yearly, Description } = req.body;
  const sqlUpdate = "UPDATE product SET phone_no=?, SKU=?,  area_code=?,Nickname=?,  monthly=?, yearly=?, Description=? WHERE id=?";
  db.query(sqlUpdate, [phone_no,  SKU, area_code,Nickname,  monthly ,yearly, Description, id], (error, result) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: "Internal Server Error"
      });
    }

    res.json({
      success: true,
      message: "Product updated successfully"
    });
  });
});


app.delete("/api/removeProduct/:id", (req, res) => {
  const id = req.params.id;
  const sqlRemove = "DELETE FROM product WHERE id = ?";
  db.query(sqlRemove, [id], (error, result) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: "Internal Server Error"
      });
    }

    res.json({
      success: true,
      message: "Product removed successfully"
    });
  });
});



////////////////////////////////////////////////////////////////////////////////////////////////

//                                          ADD TO CART        

////////////////////////////////////////////////////////////////////////////////////////////////

app.post("/api/addtocart", (req, res) => {
  const { product_id, quantity, Plan } = req.body;
  const created_at = new Date();
  
  const sqlInsert =
    "INSERT INTO cart (product_id, quantity, Plan, created_at) VALUES (?, ?, ?, ?)";
  db.query(sqlInsert, [product_id, quantity, Plan, created_at], (error, result) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: "Internal Server Error"
      });
    }

    res.json({
      success: true,
      message: "Product added to cart successfully"
    });
  });
});




app.get("/api/cart", (req, res) => {
  const sqlSelect = "SELECT * FROM cart";
  db.query(sqlSelect, (error, result) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: "Internal Server Error"
      });
    }

    res.json({
      success: true,
      data: result
    });
  });
});


app.delete("/api/cart/:id", (req, res) => {
  const id = req.params.id;
  const sqlDelete = "DELETE FROM cart WHERE id = ?";
  db.query(sqlDelete, id, (error, result) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: "Internal Server Error"
      });
    }

    res.json({
      success: true,
      message: "Item deleted from cart successfully"
    });
  });
});



////////////////////////////////////////////////////////////////////////////////////



//                                        Order api


/////////////////////////////////////////////////////////////////////////////////////








// app.post("/api/adorder", (req, res) => {
//   const { name, Date, Status, Total, user_id } = req.body;
//   const sqlInsert =
//     "INSERT INTO oder (name,Date,Status,Total,user_id) VALUES (?, ?, ?, ?, ?)";
//   db.query(sqlInsert, [name, Date, Status, Total, user_id], (error, result) => {
//     if (error) {
//       console.log(error);
//       return res.status(500).json({
//         success: false,
//         message: "Internal Server Error"
//       });
//     }

//     res.json({
//       success: true,
//       message: "Order added successfully"
//     });
//   });
// });


app.post("/api/addorder", (req, res) => {
  const { name, orderDate, Status, Total, customer_id, user_id, productIds, plan, } = req.body;

  // Convert the array of productIds to a comma-separated string
  const productIdsString = productIds.join(',');
  // const cartDataString = sessionStorage.getItem("cart");
  // const cartData = JSON.parse(cartDataString || "[]");
  
  const sqlInsert =
    "INSERT INTO oder (name, Date, Status, Total, user_id, customer_id, productIds, plan) VALUES (?, ?, ?, ?,?, ?, ?, ?)";
  db.query(sqlInsert, [name, orderDate, Status, Total, user_id, customer_id, productIdsString, plan], (error, result) => {
    if (error) {
      console.log(error);
      return res.status(500).json({ 
        success: false,
        message: "Internal Server Error"
      });
    }
    const sqlInsertNotification = "INSERT INTO notification (title, message, notify_to, user_id) VALUES (?, ?, ?, ?)";
    const notificationValues = [
      "order place",
      "Thank you for Order!",
      "admin",
      // req.body.email,
      user_id
    ];

    db.query(sqlInsertNotification, notificationValues, (err, notificationData) => {
      if (err) {
        console.error('Error inserting notification:', err);
        return res.json("Error");
      }

      // return res.json({ user: result, notification: notificationData });
    });

    
    const getUserQuery = "SELECT * FROM customers WHERE id = ?";
    db.query(getUserQuery, [customer_id], (error, customerData) => {
      if (error) {
        console.log(error);
        return res.status(500).json({
          success: false,
          message: "Internal Server Error"
        });
      }
    
      const customer = customerData[0];
      const email = customerData[0].email_address;

      
      
      const orderId = result.insertId;

      const getProductQuery = `SELECT * FROM product WHERE id IN (${productIdsString})`;
      db.query(getProductQuery, (err, productData) => {
        if (err) {
          console.error('Error fetching product details:', err);
          return res.status(500).json("Error");
        }
         
        // const products = productData;
   
    
      
      const formattedDate = new Date(orderDate).toLocaleDateString("en-US");
 // <p>Hi there! we Have Received Your Order.</p>
        // <h2>Order Details:</h2>
        // <p><strong>Name:</strong> ${name}</p>
        // <p><strong>OrderDate:</strong> ${Date}</p>
        // <p><strong>plan:</strong> ${plan}</p>
        // <p><strong>Status:</strong> ${Status}</p>
        // <p><strong>Total:</strong> ${Total}</p>
        let productsHTML = '';
        for (const product of productData) {
          productsHTML += `
            <tr>
              <td style="border:1px solid black">${product.phone_no}</td>
              <td style="border:1px solid black">1</td>
              <td style="border:1px solid black">${plan}</td>
              <td style="border:1px solid black">${"$" + parseFloat(Total).toFixed(2)}</td>
            </tr>
          `;
        }


    // Send email with order data
    const transporter = nodemailer.createTransport({
      // Configure your email provider here
      // Example using Gmail:
      service: "gmail",
      auth: {
        
        user: "mumberinvoice@gmail.com",
        pass: "sdwartoahkijpjdt"
      }
    });

    const mailOptions = {
      from: "mumber@mailinator.com",
      to: email+", mike_mumber2@mailinator.com",
      subject: "Order Received!",
      html: `
       
    
<div className='mb-5'>
<img style="float:right" src='https://mumber.com/wp-content/uploads/2020/06/logo_res-min-1.png'></img>
<h1>INVOICE</h1>
</div>


<div className='container' style="margin-top:30px">
<div className='row' style="display: flex; justify-content: space-between;">

<div className='col-lg-6'>
<h2>Order Information</h2>
    <p>Order ID: ${orderId}</p>
    <p>Name: ${name}</p>
    <p>Date: ${formattedDate}</p>
    <p>Status:<span style="color:green;">${Status}</span> </p>
    
</div>

<div className='col-lg-6' style="padding-left: 150px;">
<h2>BILL TO:</h2>
    <p>Name: ${customer.first_name} ${customer.last_name}</p>
    <p>Company: ${customer.company_name}</p>
    <p>Address: ${customer.street_address}, ${customer.town}, ${customer.state}, ${customer.ZIP_Code}</p>
    <p>Phone: ${customer.phone}</p>
    <p>Email: ${customer.email_address}</p>

</div>
</div>
</div>

<div>
<h2> ${"$" + parseFloat(Total).toFixed(2)} paid on  ${formattedDate}</h2>
</div>

<div>
<table style="border:1px solid black; width:100%">
  <tbody>
     <tr>
      <th style="border:1px solid black"><h4>Description</h4></th>
      <th style="border:1px solid black"><h4>Qty</h4></th>
      <th style="border:1px solid black"><h4>Plan</h4></th>
      <th style="border:1px solid black"><h4>Amount</h4></th>
     </tr>        

     ${productsHTML}
    
     

<tr>
      <td style="border:1px solid black"></td>
      <td style="border:1px solid black">Subtotal</td>
      <td style="border:1px solid black"> </td>
      <td style="border:1px solid black">${"$" + parseFloat(Total).toFixed(2)}</td>
     </tr>



     <tr>
      <td style="border:1px solid black"></td>
      <td style="border:1px solid black">Total</td>
      <td style="border:1px solid black"> </td>
      <td style="border:1px solid black">${"$" + parseFloat(Total).toFixed(2)}</td>
     </tr>



     <tr>
      <td style="border:1px solid black"></td>
      <td style="border:1px solid black"><h2>Amount Paid*</h2></td>
      <td style="border:1px solid black"> </td>
      <td style="border:1px solid black"><h2>${"$" + parseFloat(Total).toFixed(2)}</h2></td>
     </tr>



  </tbody>
</table>
</div>

      `
    };

    transporter.sendMail(mailOptions, (error, info) => {
      if (error) {
        console.log(error);
        return res.status(500).json({
          success: false,
          message: "Failed to send email"
        });
      }
      console.log("Email sent:", info.response);
    });

    res.json({
      success: true,
      data:result,
      message: "Order added successfully"
    });
  });
});
});
});


app.get("/api/getOrders", (req, res) => {
  const page = parseInt(req.query.page) || 1;
  const perPage = parseInt(req.query.perPage) || 10;
  const startIndex = (page - 1) * perPage;
  const search = req.query.search || '';

  // Use parameterized queries to prevent SQL injection
  const sqlGet = `SELECT * FROM oder WHERE name LIKE ? OR Date LIKE ? OR Id LIKE ? ORDER BY Id DESC LIMIT ?, ?`;
  const sqlCount = `SELECT COUNT(*) as total FROM oder WHERE name LIKE ? OR Date LIKE ? OR Id LIKE ?`;

  // Create search patterns with '%' for parameterized query
  const searchPattern = `%${search}%`;

  Promise.all([
    new Promise((resolve, reject) => {
      db.query(sqlGet, [searchPattern, searchPattern, searchPattern, startIndex, perPage], (error, results) => {
        if (error) reject(error);
        else resolve(results);
      });
    }),
    new Promise((resolve, reject) => {
      db.query(sqlCount, [searchPattern, searchPattern, searchPattern], (error, results) => {
        if (error) reject(error);
        else resolve(results[0].total);
      });
    }),
  ])
    .then(([data, total]) => {
      res.json({
        success: true,
        data,
        total,
      });
    })
    .catch((error) => {
      console.log(error);
      res.status(500).json({
        success: false,
        message: "Internal Server Error",
      });
    });
});




// app.get("/api/getOrders", (req, res) => {
//   const sqlGet = "SELECT * FROM oder ORDER BY Id DESC";
//   db.query(sqlGet, (error, results) => {
//     if (error) {
//       console.log(error);
//       return res.status(500).json({
//         success: false,
//         message: "Internal Server Error"
//       });
//     }

//     res.json({
//       success: true,
//       data: results
//     });
//   });
// });


app.get("/orders/:user_id", (req, res) => {
  const user_id = req.params.user_id;
  const sqlSelect = "SELECT * FROM users WHERE id = ?";
  db.query(sqlSelect, [user_id], (error, results) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: "Internal Server Error",
      });
    }

    res.json({
      success: true,
      data: results,
    });
  });
});


app.get('/allorders/:user_id', async (req, res) => {
  try {
    const user_id = req.params.user_id;

    // Fetch all orders for the given user_id
    const sqlSelectOrders = 'SELECT * FROM oder WHERE user_id = ?';
    const [orderResults] = await db.promise().query(sqlSelectOrders, [user_id]);

    if (orderResults.length === 0) {
      return res.status(404).json({
        success: false,
        message: 'No orders found for this user'
      });
    }

    // Collect product IDs from each order
    const productIds = orderResults.map(order => order.productIds.split(','));

    // Fetch product information for each product ID
    const sqlGetProduct = 'SELECT * FROM product WHERE id IN (?)';
    const [productResults] = await db.promise().query(sqlGetProduct, [productIds]);

    if (productResults.length === 0) {
      return res.status(404).json({
        success: false,
        message: 'Products not found'
      });
    }

    // Group product results by product ID for easier mapping
    const productMap = {};
    productResults.forEach(product => {
      productMap[product.id] = product;
    });

    // Combine order and product information
    const ordersWithProducts = orderResults.map(order => ({
      id: order.id,
      customer_id: order.customer_id,
      products: order.productIds.split(',').map(productId => productMap[productId]),
      orderDetails: order
    }));

    res.json({
      success: true,
      data: ordersWithProducts
    });
  } catch (error) {
    console.log(error);
    return res.status(500).json({
      success: false,
      message: 'Internal Server Error'
    });
  }
});


app.get('/api/getOrderDetails/:id', (req, res) => {
  const orderId = req.params.id;
  const sqlGetOrder = 'SELECT * FROM oder WHERE id = ?';
  db.query(sqlGetOrder, [orderId], (error, orderResults) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: 'Internal Server Error'
      });
    }

    if (orderResults.length === 0) {
      return res.status(404).json({
        success: false,
        message: 'Order not found'
      });
    }

    res.json({
      success: true,
      data: orderResults
    });
    // Fetch product information
   
  });
});





app.get('/api/vieworder/:id', (req, res) => {
  const orderId = req.params.id;
  const sqlGetOrder = 'SELECT * FROM oder WHERE id = ?';
  db.query(sqlGetOrder, [orderId], (error, orderResults) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: 'Internal Server Error'
      });
    }

    if (orderResults.length === 0) {
      return res.status(404).json({
        success: false,
        message: 'Order not found'
      });
    }

    const productIds = orderResults[0].productIds.split(","); // Split the comma-separated IDs into an array
    const customerId = orderResults[0].customer_id;

    // Fetch product information
    const sqlGetProduct = 'SELECT * FROM product WHERE id IN (?)';
    db.query(sqlGetProduct, [productIds], (error, productResults) => {
      if (error) {
        console.log(error);
        return res.status(500).json({
          success: false,
          message: 'Internal Server Error'
        });
      }

      if (productResults.length === 0) {
        return res.status(404).json({
          success: false,
          message: 'Products not found'
        });
      }

      // Fetch customer information
      const sqlGetCustomer = 'SELECT * FROM customers WHERE id = ?';
      db.query(sqlGetCustomer, [customerId], (error, customerResults) => {
        if (error) {
          console.log(error);
          return res.status(500).json({
            success: false,
            message: 'Internal Server Error'
          });
        }

        if (customerResults.length === 0) {
          return res.status(404).json({
            success: false,
            message: 'Customer not found'
          });
        }

        const order = {
          id: orderResults[0].id,
          products: productResults,
          customer: customerResults[0],
          orderDetails: orderResults[0]
        };

        res.json({
          success: true,
          data: order
        });
      });
    });
  });
});




app.get("/api/getCustomer/:email", (req, res) => {
  console.log(req.params.email);
  const sqlGet = "SELECT * FROM customers where email_address=?";
  db.query(sqlGet, [req.params.email], (error, customerResults) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: 'Internal Server Error'
      });
    }

    if (customerResults.length === 0) {
      return res.status(200).json({
        success: false,
        message: 'Customer not found'
      });
    }

    const order = {
      Id: customerResults[0].gateway_customer_id,
      card_id: customerResults[0].card_id
    };

    res.json({
      success: true,
      data: order
    });
  });
});










app.get("/api/countorder", (req, res) => {
  const sqlGet = "SELECT COUNT(*) AS total FROM oder"; // Modified query to get the total count
  db.query(sqlGet, (error, countResult) => { // Renamed 'results' to 'countResult'
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: "Internal Server Error"
      });
    }

    const totalCount = countResult[0].total; // Extract the total count from the query result

    const sqlGetOrders = "SELECT * FROM oder ORDER BY Id DESC";
    db.query(sqlGetOrders, (error, ordersResult) => { // Renamed 'results' to 'ordersResult'
      if (error) {
        console.log(error);
        return res.status(500).json({
          success: false,
          message: "Internal Server Error"
        });
      }

      res.json({
        success: true,
        totalCount: totalCount, // Include the total count in the response
        data: ordersResult // Rename 'results' to 'ordersResult'
      });
    });
  });
});




app.delete("/api/removeOrder/:id", (req, res) => {
  const id = req.params.id;
  const sqlRemove = "DELETE FROM oder WHERE id = ?";
  db.query(sqlRemove, [id], (error, result) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: "Internal Server Error"
      });
    }

    res.json({
      success: true,
      message: "Order removed successfully"
    });
  });
});




// app.put("/api/updateOrder/:id", (req, res) => {
//   const id = req.params.id;
//   const { name, Date, Status, Total } = req.body;
//   const sqlUpdate = "UPDATE oder SET name=?, Date=?, Status=?, Total=? WHERE id=?";
//   db.query(sqlUpdate, [name, Date, Status, Total, id], (error, result) => {
//     if (error) {
//       console.log(error);
//       return res.status(500).json({
//         success: false,
//         message: "Internal Server Error"
//       });
//     }

//     res.json({
//       success: true,
//       message: "Order updated successfully"
//     });
//   });
// });


app.put("/api/updateOrder/:id", (req, res) => {
  const id = req.params.id;
  const { name, OrderDate, Status, Total } = req.body;
  const sqlUpdate = "UPDATE oder SET name=?, OrderDate=?, Status=?, Total=? WHERE id=?";
  db.query(sqlUpdate, [name, OrderDate, Status, Total, id], (error, result) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: "Internal Server Error"
      });
    }

    const transporter = nodemailer.createTransport({
      service: "gmail",
      auth: {
        
        user: "mumberinvoice@gmail.com",
        pass: "sdwartoahkijpjdt"
      }
    });

    const mailOptions = {
      from: "abhi malik",
      to: "abhishekm5kwt@gmail.com , malikabhi649@gmail.com",
      subject: "Order Updated",
      html: `
        <h2>Updated Order Details:</h2>
        <p><strong>Name:</strong> ${name}</p>
        <p><strong>OrderDate:</strong> ${OrderDate}</p>
        <p><strong>Status:</strong> ${Status}</p>
        <p><strong>Total:</strong> ${Total}</p>
        <p><strong>Order ID:</strong> ${id}</p>
      `
    };

    transporter.sendMail(mailOptions, (error, info) => {
      if (error) {
        console.log(error);
        return res.status(500).json({
          success: false,
          message: "Failed to send email"
        });
      }
      console.log("Email sent:", info.response);
    });

    res.json({
      success: true,
      message: "Order updated successfully"
    });
  });
});





app.get('/api/order/:id', (req, res) => {
  const productId = req.params.id;
  const sqlGetById = 'SELECT * FROM oder WHERE id = ?';
  db.query(sqlGetById, [productId], (error, results) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: 'Internal Server Error'
      });
    }

    if (results.length === 0) {
      return res.status(404).json({
        success: false,
        message: 'Order not found'
      });
    }

    res.json({
      success: true,
      data: results[0]
    });
  });
});



////////////////////////////////////////////////////////////////////////////////////

//                                  blogs api 

////////////////////////////////////////////////////////////////////////////////////

app.post("/api/addblog", upload.single("image"), (req, res) => {
  const { Title,  Description, ShortDescription, Tags, Meta_keywords, Meta_description } = req.body;
  const image = req.file.filename; // get the filename of the uploaded image

  const sqlInsert =
    "INSERT INTO blogs (Title,  Description, ShortDescription, Tags, Meta_keywords, Meta_description, images) VALUES (?, ?, ?, ?, ?, ?, ?)";
  db.query(sqlInsert, [Title, Description, ShortDescription, Tags, Meta_keywords, Meta_description, image], (error, result) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: "Internal Server Error"
      });
    }

    res.json({
      success: true,
      message: "blog added successfully"
    });
  });
});





app.get("/api/allblogs", (req, res) => {
  const sqlGet = "SELECT *, DATE_FORMAT(created_at, '%Y-%m-%d') AS created_date FROM blogs ORDER BY Id DESC";

  db.query(sqlGet, (error, results) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: "Internal Server Error"
      });
    }

    const blogs = results.map((blog) => {
      return {
        Id: blog.Id,
        Title: blog.Title,
        // Categories: blog.Categories,
        Description: blog.Description,
        ShortDescription: blog.ShortDescription,
        Tags: blog.Tags,
        Meta_keywords: blog.Meta_keywords,
        Meta_description: blog.Meta_description,
        images: `https://node.mumber.com/uploads/${blog.images}`,
        created_date: blog.created_date ,
      };
    });

    res.json({
      success: true,
      data: blogs
    });
  });
});
// app.get("/api/allblogs",(req, res)=>{
//   const sqlGet = "SELECT * FROM blogs ORDER BY Id DESC ";

//   db.query(sqlGet, (error, result) => {
  
//       res.send(result);
//   });
// });


// app.get('/api/suggestions', (req, res) => {
//   const query = req.query.query;
//   const sql = `SELECT * FROM product WHERE phone_no LIKE '%${query}%'`;
//   db.query(sql, (err, results) => {
//     if (err) throw err;
//     res.json(results);
//   });
// });


app.get('/api/suggestions', (req, res) => {
  const query = req.query.query;
  const sql = `SELECT * FROM product WHERE phone_no LIKE '${query}%' AND Is_sold = 0 OR Description LIKE '%${query}%' AND Is_sold = 0 OR nickname LIKE '%${query}%' AND Is_sold = 0 LIMIT 10`;
  db.query(sql, (err, results) => {
    if (err) throw err;
    res.json(results);
  });
});



// app.get('/api/suggestions', (req, res) => {
//   const query = req.query.query;
//   const field = req.query.field; // Retrieve the field from the query parameter
//   let sql = '';

//   if (field === 'phone_no') {
//     sql = `SELECT * FROM product WHERE phone_no LIKE '%${query}%'`;
//   } else if (field === 'state') {
//     sql = `SELECT * FROM product WHERE State LIKE '%${query}%'`;
//   } else if (field === 'area_code') {
//     sql = `SELECT * FROM product WHERE area_code LIKE '%${query}%'`;
//   }

//   db.query(sql, (err, results) => {
//     if (err) throw err;
//     res.json(results);
//   });
// });




app.get("/api/latestblogs", (req, res) => {
  const sqlGet = "SELECT * FROM blogs ORDER BY Id DESC LIMIT 4";
  db.query(sqlGet, (error, results) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: "Internal Server Error"
      });
    }

    const blogs = results.map((blog) => {
      return {
        Id: blog.Id,
        Title: blog.Title,
        // Categories: blog.Categories,
        Description: blog.Description,
        ShortDescription: blog.ShortDescription,
        Tags: blog.Tags,
        Meta_keywords: blog.Meta_keywords,
        Meta_description: blog.Meta_description,
        created_at: blog.created_at,
        images: `https://node.mumber.com/uploads/${blog.images}`
      };
    });

    res.json({
      success: true,
      data: blogs
    });
  });
});







app.delete("/api/removeBlog/:id", (req, res) => {
  const id = req.params.id;
  const sqlRemove = "DELETE FROM blogs WHERE id = ?";
  db.query(sqlRemove, [id], (error, result) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: "Internal Server Error"
      });
    }

    res.json({
      success: true,
      message: "Blog removed successfully"
    });
  });
});


app.use('/uploads', express.static(path.join(__dirname, 'uploads')));




app.put('/api/updateBlog/:id', upload.single('image'), (req, res) => {
  const { Title,Description, ShortDescription, Tags, Meta_keywords, Meta_description } = req.body;
  const image = req.file ? req.file.filename : undefined; // get the filename of the uploaded image, if any

  const id = req.params.id;
  const sqlSelect = "SELECT * FROM blogs WHERE Id = ?";
  db.query(sqlSelect, [id], (error, results) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: "Internal Server Error"
      });
    }

    if (results.length === 0) {
      return res.status(404).json({
        success: false,
        message: "Blog not found"
      });
    }

    const blog = results[0];
    const oldImage = blog.images;

    const sqlUpdate =
      "UPDATE blogs SET Title = ?,  Description = ?, ShortDescription = ?, Tags = ?, Meta_keywords = ?, Meta_description = ?, images = ? WHERE Id = ?";
    db.query(sqlUpdate, [Title,  Description, ShortDescription, Tags, Meta_keywords, Meta_description, image || oldImage, id], (error, result) => {
      if (error) {
        console.log(error);
        return res.status(500).json({
          success: false,
          message: "Internal Server Error"
        });
      }

      // Delete old image if a new image was uploaded
      if (image && oldImage) {
        const imagePath = path.join(__dirname, 'uploads', oldImage);
        fs.unlink(imagePath, (error) => {
          if (error) {
            console.log(error);
          }
        });
      }

      res.json({
        success: true,
        message: "Blog updated successfully"
      });
    });
  });
});






app.get('/api/blog/:id', (req, res) => {
  const BlogId = req.params.id;
  const sqlGetById = 'SELECT * FROM blogs WHERE id = ?';
  db.query(sqlGetById, [BlogId], (error, results) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: 'Internal Server Error'
      });
    }

    if (results.length === 0) {
      return res.status(404).json({
        success: false,
        message: 'blog not found'
      });
    }

    res.json({
      success: true,
      data: results[0]
    });
  });
});


app.get("/api/countblogs", (req, res) => {
  const sqlGet = "SELECT COUNT(*) AS total FROM blogs";
  db.query(sqlGet, (error, countResult) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: "Internal Server Error",
      });
    }

    const totalCount = countResult[0].total;

    res.json({
      success: true,
      totalCount: totalCount,
    });
  });
});








////////////////////////////////////////////////////////////////////////////////////////////

                              //categories api

////////////////////////////////////////////////////////////////////////////////////////////


app.post("/api/addcategorie", (req, res) => {
  const { Categorie_name } = req.body;
  const sqlInsert =
    "INSERT INTO categories (Categorie_name) VALUES (?)";
  db.query(sqlInsert, [Categorie_name], (error, result) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: "Internal Server Error"
      });
    }

    res.json({
      success: true,
      message: "categorie added successfully"
    });
  });
});


app.get("/api/get_gateway_settings", (req, res) => {
  const sqlGet = "SELECT * FROM gateway_settings";
  db.query(sqlGet, (error, results) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: "Internal Server Error"
      });
    }

    res.json({
      success: true,
      data: results
    });
  });
});


app.get("/api/getCategories", (req, res) => {
  const sqlGet = "SELECT * FROM categories";
  db.query(sqlGet, (error, results) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: "Internal Server Error"
      });
    }

    res.json({
      success: true,
      data: results[0]
    });
  });
});

app.get("/api/countcategories", (req, res) => {
  const sqlCount = "SELECT COUNT(*) AS total FROM categories";
  db.query(sqlCount, (error, countResult) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: "Internal Server Error"
      });
    }

    const totalCount = countResult[0].total;

    res.json({
      success: true,
      totalCount: totalCount
    });
  });
});




app.delete("/api/removeCategorie/:id", (req, res) => {
  const id = req.params.id;
  const sqlRemove = "DELETE FROM categories WHERE id = ?";
  db.query(sqlRemove, [id], (error, result) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: "Internal Server Error"
      });
    }

    res.json({
      success: true,
      message: "Categorie removed successfully"
    });
  });
});




app.put("/api/updateCategorie/:id", (req, res) => {
  const id = req.params.id;
  const { Categorie_name } = req.body;
  const sqlUpdate = "UPDATE categories SET  Categorie_name=? WHERE id=?";
  db.query(sqlUpdate, [Categorie_name, id], (error, result) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: "Internal Server Error"
      });
    }

    res.json({
      success: true,
      message: "Categorie updated successfully"
    });
  });
});





app.get('/api/Categorie/:id', (req, res) => {
  const CategorieID = req.params.id;
  const sqlGetById = 'SELECT * FROM categories WHERE id = ?';
  db.query(sqlGetById, [CategorieID], (error, results) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: 'Internal Server Error'
      });
    }

    if (results.length === 0) {
      return res.status(404).json({
        success: false,
        message: 'Categorie not found'
      });
    }

    res.json({
      success: true,
      data: results[0]
    });
  });
});

///////////////////////////////////////////////////////////////////////////////////


app.post('/create-checkout-session', async (req, res) => {
  try {
    const productId = req.body.productId; // Assuming the product ID is passed in the request body
    const sqlSelect = "SELECT phone_no, plan, licence_fee FROM product WHERE id = ?";
    db.query(sqlSelect, [productId], async (error, result) => {
      if (error || result.length === 0) {
        console.log(error);
        return res.status(500).json({
          success: false,
          message: "Internal Server Error"
        });
      }
      
      const { phone_no, plan, licence_fee } = result[0];
      
      const session = await stripe.checkout.sessions.create({
        payment_method_types: ['card'],
        line_items: [
          {
            price_data: {
              currency: 'usd',
              product_data: {
                name: phone_no,
              },
              unit_amount: licence_fee,
            },
            quantity: 1,
          },
        ],
        mode: 'payment',
        success_url: 'http://localhost:3000/success',
        cancel_url: 'http://localhost:3000/cancel',
      });

      res.json({ id: session.id });
    });
  } catch (error) {
    console.log(error);
    return res.status(500).json({
      success: false,
      message: "Internal Server Error"
    });
  }
});



//////////////////////////////////////////////////////////

app.post("/api/addreview", (req, res) => {
  const { customer_name, description, rating } = req.body;
  const sqlInsert =
    "INSERT INTO customer_reviews (customer_name, description, rating) VALUES (?, ?, ?)";
  db.query(sqlInsert, [customer_name, description, rating], (error, result) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: "Internal Server Error"
      });
    }

    res.json({
      success: true,
      message: "customer review added successfully"
    });
  });
});





app.get("/api/getreview", (req, res) => {
  const sqlGet = "SELECT * FROM customer_reviews";
  db.query(sqlGet, (error, results) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: "Internal Server Error"
      });
    }

    res.json({
      success: true,
      data: results
    });
  });
});





app.delete("/api/removereview/:id", (req, res) => {
  const id = req.params.id;
  const sqlRemove = "DELETE FROM customer_reviews WHERE id = ?";
  db.query(sqlRemove, [id], (error, result) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: "Internal Server Error"
      });
    }

    res.json({
      success: true,
      message: "reviews removed successfully"
    });
  });
});



app.put("/api/updatereviews/:id", (req, res) => {
  const id = req.params.id;
  const { customer_name, description, rating } = req.body;
  const sqlUpdate = "UPDATE customer_reviews  SET  customer_name=?, description=?, rating=? WHERE id=?";
  db.query(sqlUpdate, [customer_name, description, rating, id], (error, result) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: "Internal Server Error"
      });
    }

    res.json({
      success: true,
      message: " updated successfully"
    });
  });
});





app.get('/api/reviews/:id', (req, res) => {
  const CategorieID = req.params.id;
  const sqlGetById = 'SELECT * FROM customer_reviews WHERE id = ?';
  db.query(sqlGetById, [CategorieID], (error, results) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: 'Internal Server Error'
      });
    }

    if (results.length === 0) {
      return res.status(404).json({
        success: false,
        message: 'Categorie not found'
      });
    }

    res.json({
      success: true,
      data: results[0]
    });
  });
});

//////////////////////////////////////////////////////////////////////////////////////////////////

//                                          COUSTOMER API


///////////////////////////////////////////////////////////////////////////////////////////////////
app.post('/gatewayCustomer', async (req, res) => {
  try {
    const { url, data, token } = req.body;

    // Make the API request to the desired endpoint
    const response = await axios.post(url, data, {
        headers: {
          'Content-Type': 'application/json',
          'Authorization': 'Bearer ' + token,
          'Accept': 'application/json',
         
          'request-Id': Date.now()
        }
      });



     

    // Forward the API response back to the client
    res.send(response.data);
  } catch (error) {
    // Handle any errors
    res.status(500).send(error.message);
  }
});



app.post('/api/update_customer_next_invoice', (req, res) => {
 
  const {data} = req.body;

  try {
    if(data.current_invoice_id!=undefined){

      
  // Check if the customer already exists in the "customers" table
  const checkCustomerQuery = "SELECT * FROM customers WHERE id = ?";
  db.query(checkCustomerQuery, [data.user_id], (error, results) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: "Internal Server Error"
      });
    }

    if (results.length > 0) {
      
      


    // Send email with order data
    const transporter = nodemailer.createTransport({
      // Configure your email provider here
      // Example using Gmail:
      service: "gmail",
      auth: {
        
        user: "mumberinvoice@gmail.com",
        pass: "sdwartoahkijpjdt"
      }
    });

    const mailOptions = {
      from: "mumber@mailinator.com",
      to: results[0].email_address+", mike_mumber2@mailinator.com",
      subject: "Payment Received!",
      html: `
        <p>Hi There! We have received your payment.</p>
        <br>
        <h2>Payment Details:</h2>
        <p><strong>Amount:</strong> ${data.amount}</p>
        <p><strong>Plan:</strong> ${data.plan}</p>
        <p><strong>Status:</strong> Completed</p>
       
      `
    };

    transporter.sendMail(mailOptions, (error, info) => {
      if (error) {
        console.log(error);
        return res.status(500).json({
          success: false,
          message: "Failed to send email"
        });
      }
      console.log("Email sent:", info.response);
    });
      
    }

    
  });

      const sqlUpdate = "UPDATE invoices SET paid=? WHERE id=?";
      db.query(sqlUpdate, [1,  data.current_invoice_id], (error, result) => {
        if (error) {
          console.log(error);
          return res.status(500).json({
            success: false,
            message: "Internal Server Error"
          });
        }




        // res.send(result);
      });
    }
    

    // Forward the API response back to the client
   
  } catch (error) {
    // Handle any errors
    res.status(500).send(error.message);
  }
  try {



    

    const sqlInsert = "INSERT INTO invoices (due_on, invoice_id, amount, plan, user_id, order_id) VALUES (?,?,?,?,?,?)";
    db.query(sqlInsert, [data.date, data.invoice_id, data.amount, data.plan, data.user_id, data.order_id], (error, result) => {
      if (error) {
        console.log(error);
        return res.status(500).json({
          success: false,
          message: "Internal Server Error"
        });
      }

      res.json({
        id: result.insertId,
        success: true,
        message: "Invoice added successfully"
      });
    });
    

   

    // Forward the API response back to the client
   
  } catch (error) {
    // Handle any errors
    res.status(500).send(error.message);
  }
});


app.get('/api/update_customerid/:id/:email', (req, res) => {
 
  try {
    const sqlUpdate = "UPDATE customers SET card_id=? WHERE email_address=?";
    db.query(sqlUpdate, [req.params.id,  req.params.email], (error, result) => {
      if (error) {
        console.log(error);
        return res.status(500).json({
          success: false,
          message: "Internal Server Error"
        });
      }

      res.send(result);
    });

    // Forward the API response back to the client
   
  } catch (error) {
    // Handle any errors
    res.status(500).send(error.message);
  }
});


app.post('/create_payment', async (req, res) => {
  try {
    const { url, data, token } = req.body;

    // Make the API request to the desired endpoint
    const response = await axios.post(url, data, {
        headers: {
          'Content-Type': 'application/json',
          'Authorization': 'Bearer ' + token,
          'Accept': 'application/json',
         
          'request-Id': Date.now()
        }
      });

    // Forward the API response back to the client
    res.send(response.data);
  } catch (error) {
    // Handle any errors
    res.status(500).send(error.message);
  }
});

app.post('/send_invoice', async (req, res) => {
  try {
    const { url, token } = req.body;
    console.log(req.body);
    // Make the API request to the desired endpoint
    const response = await axios.post(url, [], {
        headers: {
          'Content-Type': 'application/octet-stream',
          'Authorization': 'Bearer ' + token,
          'Accept': 'application/json',
         
          'request-Id': Date.now()
        }
      });

    // Forward the API response back to the client
    res.send(response.data);
  } catch (error) {
    // Handle any errors
    res.status(500).send(error);
  }
});

app.post('/generate_invoice', async (req, res) => {
  try {
    const { url, data, token } = req.body;

    // Make the API request to the desired endpoint
    const response = await axios.post(url, data, {
        headers: {
          'Content-Type': 'application/json',
          'Authorization': 'Bearer ' + token,
          'Accept': 'application/json',
         
          'request-Id': Date.now()
        }
      });


    // Forward the API response back to the client
    res.send(response.data);
  } catch (error) {
    // Handle any errors
    res.status(500).send(error);
  }
});


app.post('/seller', async (req, res) => {
  try {
    const { url, data, token } = req.body;

    // Make the API request to the desired endpoint
    const response = await axios.post(url, data, {
        headers: {
          'Content-Type': 'application/json',
          'Authorization': 'Bearer ' + token,
          'Accept': 'application/json',
         
          'request-Id': Date.now()
        }
      });

    // Forward the API response back to the client
    res.send(response.data);
  } catch (error) {
    // Handle any errors
    res.status(500).send(error.message);
  }
});

app.post("/api/addcustomer", (req, res) => {



  const { first_name, last_name, company_name, street_address, town, state, ZIP_Code, phone, email_address,userId, gateway_customer_id } = req.body;

  // Check if the customer already exists in the "customers" table
  const checkCustomerQuery = "SELECT id,userId FROM customers WHERE email_address = ?";
  db.query(checkCustomerQuery, [email_address], (error, results) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: "Internal Server Error"
      });
    }

    if (results.length > 0) {
      // Customer already exists, return the existing customer ID
      const existingCustomerId = results[0].id;
      const userd = results[0].userId;
      return res.json({
        success: true,
        userid: userd,
        message: "Customer already exists",
        id: existingCustomerId,
        
      });
    }

    // Customer does not exist, proceed with inserting the customer
    const sqlInsert = "INSERT INTO customers (first_name, last_name, company_name, street_address, town, state, ZIP_Code, phone, email_address,userId, gateway_customer_id) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?,?, ?)";
    db.query(sqlInsert, [first_name, last_name, company_name, street_address, town, state, ZIP_Code, phone, email_address,userId,gateway_customer_id], (error, result) => {
      if (error) {
        console.log(error);
        return res.status(500).json({
          success: false,
          message: "Internal Server Error"
        });
      }

      res.json({
        id: result.insertId,
        success: true,
        message: "Customer added successfully"
      });
    });
  });
});



app.get("/api/countcustomers", (req, res) => {
  const sqlGetCount = "SELECT COUNT(*) AS total FROM customers";
  db.query(sqlGetCount, (error, countResult) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: "Error retrieving customer count",
      });
    }

    const totalCount = countResult[0].total;

    res.json({
      success: true,
      totalCount: totalCount,
    });
  });
});





// app.get("/api/getcustomers", (req, res) => {
//   const sqlGet = "SELECT * FROM customers order by id desc";
//   db.query(sqlGet, (error, results) => {
//     if (error) {
//       console.log(error);
//       return res.status(500).json({
//         success: false,
//         message: "Internal Server Error"
//       });
//     }

//     res.json({
//       success: true,
//       data: results
//     });
//   });
// });


app.get("/api/getcustomers", (req, res) => {
  const page = parseInt(req.query.page) || 1;
  const perPage = parseInt(req.query.perPage) || 10;
  const startIndex = (page - 1) * perPage;
  const search = req.query.search || '';

  // Use parameterized queries to prevent SQL injection
  const sqlGet = `
    SELECT *
    FROM customers
    WHERE first_name LIKE ? OR last_name LIKE ? OR email_address LIKE ?
    ORDER BY id DESC
    LIMIT ?, ?
  `;
  const sqlCount = `
    SELECT COUNT(*) as total
    FROM customers
    WHERE first_name LIKE ? OR last_name LIKE ? OR email_address LIKE ?
  `;

  // Create search patterns with '%' for parameterized query
  const searchPattern = `%${search}%`;

  Promise.all([
    new Promise((resolve, reject) => {
      db.query(sqlGet, [searchPattern, searchPattern, searchPattern, startIndex, perPage], (error, results) => {
        if (error) reject(error);
        else resolve(results);
      });
    }),
    new Promise((resolve, reject) => {
      db.query(sqlCount, [searchPattern, searchPattern, searchPattern], (error, results) => {
        if (error) reject(error);
        else resolve(results[0].total);
      });
    }),
  ])
    .then(([data, total]) => {
      res.json({
        success: true,
        data,
        total,
      });
    })
    .catch((error) => {
      console.log(error);
      res.status(500).json({
        success: false,
        message: "Internal Server Error",
      });
    });
});







app.get("/api/getcustomersinvoices", (req, res) => {
  const sqlGet = "SELECT invoices.*, customers.first_name, customers.last_name, customers.email_address, customers.gateway_customer_id, customers.card_id FROM invoices left join customers on invoices.user_id = customers.id order by invoices.id desc";
  db.query(sqlGet, (error, results) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: "Internal Server Error"
      });
    }

    res.json({
      success: true,
      data: results
    });
  });
});




app.get('/api/customer/:id', (req, res) => {
  const customerId = req.params.id;
  const sqlGetById = 'SELECT * FROM customers WHERE id = ? ';
  db.query(sqlGetById, [customerId], (error, results) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: 'Internal Server Error'
      });
    }

    if (results.length === 0) {
      return res.status(404).json({
        success: false,
        message: 'customer not found'
      });
    }

    res.json({
      success: true,
      data: results[0]
    });
  });
});



app.put("/api/updatecustomer/:id", (req, res) => {
  const id = req.params.id;
  const { first_name, last_name, company_name, street_address,town, state , ZIP_Code , phone , email_address } = req.body;
  const sqlUpdate = "UPDATE customers SET first_name=?, last_name=?, company_name=?, street_address=?,town=?, state=? , ZIP_Code=? , phone=? , email_address=? WHERE id=?";
  db.query(sqlUpdate, [first_name, last_name, company_name, street_address,town, state , ZIP_Code , phone , email_address, id], (error, result) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: "Internal Server Error"
      });
    }

    res.json({
      success: true,
      message: "customer updated successfully"
    });
  });
});


app.delete("/api/removecustomer/:id", (req, res) => {
  const id = req.params.id;
  const sqlRemove = "DELETE FROM customers WHERE id = ?";
  db.query(sqlRemove, [id], (error, result) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: "Internal Server Error"
      });
    }

    res.json({
      success: true,
      message: "customer removed successfully"
    });
  });
});

///////////////////////////////////////////////////////////////////////////////////////////////////

//                                           FAQ

//////////////////////////////////////////////////////////////////////////////////////////////////////


app.post("/api/addfaq", upload.single("image"), (req, res) => {
  const { Description,ShortDescription, Title } = req.body;
  const image = req.file.filename; // get the filename of the uploaded image

  const sqlInsert =
    "INSERT INTO faqs (Description,ShortDescription,Title,image) VALUES (?,?, ?,?)";
  db.query(sqlInsert, [ Description,ShortDescription,Title, image], (error, result) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: "Internal Server Error"
      });
    }

    res.json({
      success: true,
      message: "faq added successfully"
    });
  });
});



app.get("/api/allfaqs", (req, res) => {
  const sqlGet = "SELECT * FROM faqs ORDER BY Id DESC ";
  db.query(sqlGet, (error, results) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: "Internal Server Error"
      });
    }

    const faqs = results.map((faq) => {
      return {
        Id: faq.id,
        Description: faq.Description,
        ShortDescription: faq.ShortDescription,
        Title: faq.Title,
        images: `https://node.mumber.com/uploads/${faq.image}`
      };
    });

    res.json({
      success: true,
      data: faqs
    });
  });
});



app.delete("/api/removefaq/:id", (req, res) => {
  const id = req.params.id;
  const sqlRemove = "DELETE FROM faqs WHERE id = ?";
  db.query(sqlRemove, [id], (error, result) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: "Internal Server Error"
      });
    }

    res.json({
      success: true,
      message: "Blog removed successfully"
    });
  });
});


app.use('/uploads', express.static(path.join(__dirname, 'uploads')));




app.put('/api/updatefaq/:id', upload.single('image'), (req, res) => {
  const { Description,ShortDescription, Title } = req.body;
  const image = req.file ? req.file.filename : undefined; // get the filename of the uploaded image, if any

  const id = req.params.id;
  const sqlSelect = "SELECT * FROM faqs WHERE Id = ?";
  db.query(sqlSelect, [id], (error, results) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: "Internal Server Error"
      });
    }

    if (results.length === 0) {
      return res.status(404).json({
        success: false,
        message: "FAQ not found"
      });
    }

    const faq = results[0];
    const oldImage = faq.image;

    const sqlUpdate = "UPDATE faqs SET Description = ?,ShortDescription=?, Title=?, image = ? WHERE Id = ?";
    db.query(sqlUpdate, [Description,ShortDescription,Title, image || oldImage, id], (error, result) => {
      if (error) {
        console.log(error);
        return res.status(500).json({
          success: false,
          message: "Internal Server Error"
        });
      }

      // Delete old image if a new image was uploaded
      if (image && oldImage) {
        const imagePath = path.join(__dirname, 'uploads', oldImage);
        fs.unlink(imagePath, (error) => {
          if (error) {
            console.log(error);
          }
        });
      }

      res.json({
        success: true,
        message: "FAQ updated successfully"
      });
    });
  });
});





app.get('/api/faq/:id', (req, res) => {
  const faqId = req.params.id;
  const sqlGetById = 'SELECT * FROM faqs WHERE id = ?';
  db.query(sqlGetById, [faqId], (error, results) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: 'Internal Server Error'
      });
    }

    if (results.length === 0) {
      return res.status(404).json({
        success: false,
        message: 'faq not found'
      });
    }

    res.json({
      success: true,
      data: results[0]
    });
  });
});


app.get("/api/latestfaqs", (req, res) => {
  const sqlGet = "SELECT * FROM faqs ORDER BY Id DESC LIMIT 4";
  db.query(sqlGet, (error, results) => {
    if (error) {
      console.log(error);
      return res.status(500).json({
        success: false,
        message: "Internal Server Error"
      });
    }

    const faqs = results.map((faq) => {
      return {
        Id: faq.id,
        Title: faq.Title,
        Description: faq.Description,
        images: `https://node.mumber.com/uploads/${faq.image}`
      };
    });

    res.json({
      success: true,
      data: faqs
    });
  });
});



///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


app.post('/login', [
  check('email', "Email length error").isEmail().isLength({ min: 10, max: 30 }),
  check('password', "Password length 8-10").isLength({ min: 8, max: 10 })
], (req, res) => {
  const errors = validationResult(req);

  if (!errors.isEmpty()) {
    return res.json(errors.array());
  }

  const { email, password } = req.body;

  const sqlSelect = "SELECT * FROM users WHERE email = ?";
  db.query(sqlSelect, [email], (err, data) => {
    if (err) {
      console.log(err);
      return res.json("Error");
    }

    if (data.length > 0) {
      const user = data[0];

      // Compare the entered password with the hashed password in the database
      bcrypt.compare(password, user.password, (bcryptErr, passwordMatch) => {
        if (bcryptErr) {
          console.log(bcryptErr);
          return res.json("Error");
        }

        if (passwordMatch) {
          // Passwords match, user is authenticated
          // You can generate a JWT token or set a session here for authentication

          return res.json({
            Success: 1,
            users: data
          });
        } else {
          // Passwords do not match
          return res.json("Failed");
        }
      });
    } else {
      return res.json("Failed");
    }
  });
});


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//                                               favourites

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

app.post('/favorites', (req, res) => {
  const { userId, productId } = req.body;

  // Insert the favorite item into the database
  const query = 'INSERT INTO favorites (userId, productId) VALUES (?, ?)';
  db.query(query, [userId, productId], (error, results) => {
    if (error) {
      console.error('Error adding product to favorites', error);
      return res.status(500).json({ error: 'Failed to add product to favorites' });
    }
    return res.status(200).json({ message: 'Product added to favorites' });
  });
});

app.get('/favorites/:userId', (req, res) => {
  const userId = req.params.userId;

  // Retrieve favorites from the database for the specified user
  const query = 'SELECT favorites.productId, product.* FROM favorites JOIN product ON favorites.productId = product.id WHERE favorites.userId = ?';
  db.query(query, [userId], (error, results) => {
    if (error) {
      console.error('Error fetching favorites', error);
      return res.status(500).json({ error: 'Failed to fetch favorites' });
    }
    return res.status(200).json(results);
  });
});


// DELETE route to remove a favorite
app.delete('/favorites/:productId', (req, res) => {
  const productId = req.params.productId;

  // Delete the favorite from the database
  const query = 'DELETE FROM favorites WHERE productId = ?';
  db.query(query, [productId], (error, results) => {
    if (error) {
      console.error('Error deleting favorite', error);
      return res.status(500).json({ error: 'Failed to delete favorite' });
    }
    if (results.affectedRows === 0) {
      // No rows were affected, favorite not found
      return res.status(404).json({ error: 'Favorite not found' });
    }
    return res.status(200).json({ message: 'Favorite deleted' });
  });
});



//////////////////////////////////////////////////////////////////////////////////////////////////////////////////


        app.get('/api/get/phone_no',(req,res) =>{
          const getItems = "SELECT distinct(phone_no) FROM product;"
          db.query(getItems,(err,result) =>{
              res.send(result)
          })
      })
app.listen(5000, () => {
  console.log("Server is running on port 5000");
});